;----------------------------------------------------------------------------------------------------------
; CountDown\3_Decades.asm
;----------------------------------------------------------------------------------------------------------
; Dieser Programmteil wird dazu benutzt, die mittels Taste 1 gewhlte Dekade blinken zu lassen.
; Die zuvor schon gewhlten Dekaden leuchten konstant mit den jeweils mit Taste 2 eingestellten Werten.
;----------------------------------------------------------------------------------------------------------
; Stunden x 10

Dunk01:
		cli
		rcall	outCon						; No Shutdown, Data Coming, Decode, Code B
		ldi		Number	,	0b00001111		; Blank
		rcall	outDig						; Dekade 1 (ganz rechts)
		rcall	outDig						; Dekade 2
		rcall	outDig						; Dekade 3
		rcall	outDig						; Dekade 4
		rcall	outDig						; Dekade 5
		rcall	outDig						; Dekade 6
		rcall	outDig						; Dekade 7
		rcall	outDig						; Dekade 8 (ganz links)
		ldi		Number	,	0b00001111		; Blank

		ret

;----------------------------------------------------------------------------------------------------------
; Stunden x 10

Hell01:
		cli
		rcall	outCon						; No Shutdown, Data Coming, Decode, Code B
		ldi		Number	,	0b00001111		; Blank
		rcall	outDig						; Dekade 1
		rcall	outDig						; Dekade 2
		rcall	outDig						; Dekade 3
		rcall	outDig						; Dekade 4
		rcall	outDig						; Dekade 5
		rcall	outDig						; Dekade 6
		rcall	outDig						; Dekade 7
		mov		Number	,	mCoun1			; '0', '1' oder '2'
		rcall	outDig						; Dekade 8
		ldi		Number	,	0b00001111		; Blank
		ret

;----------------------------------------------------------------------------------------------------------
; Stunden x 1

Dunk02:
		cli
		rcall	outCon
		ldi		Number	,	0b00001111
		rcall	outDig
		rcall	outDig
		rcall	outDig
		rcall	outDig
		rcall	outDig
		rcall	outDig
		rcall	DP1							; Dezimalpunkt fr Dekade 7 = Stunden x 1, Signal Ein
		rcall	outDig
		rcall	DP2							; Dezimalpunkt fr Dekade 7 = Stunden x 1, Signal Aus
		mov		Number	,	mCoun1
		rcall	outDig
		ldi		Number	,	0b00001111
		ret

;----------------------------------------------------------------------------------------------------------
; Stunden x 1

Hell02:
		cli
		rcall	outCon
		ldi		Number	,	0b00001111
		rcall	outDig
		rcall	outDig
		rcall	outDig
		rcall	outDig
		rcall	outDig
		rcall	outDig
		rcall	DP1
		mov		Number	,	mCoun2
		rcall	outDig
		rcall	DP2
		mov		Number	,	mCoun1
		rcall	outDig
		ldi		Number	,	0b00001111
		
		ret

;----------------------------------------------------------------------------------------------------------
; Minuten x 10

Dunk03:
		cli
		rcall	outCon
		ldi		Number	,	0b00001111
		rcall	outDig
		rcall	outDig
		rcall	outDig
		rcall	outDig
		rcall	outDig
		rcall	outDig
		rcall	DP1
		mov		Number	,	mCoun2
		rcall	outDig
		rcall	DP2
		mov		Number	,	mCoun1
		rcall	outDig
		ldi		Number	,	0b00001111
		
		ret

;----------------------------------------------------------------------------------------------------------
; Minuten x 10

Hell03:
		cli
		rcall	outCon
		ldi		Number	,	0b00001111
		rcall	outDig
		rcall	outDig
		rcall	outDig
		rcall	outDig
		rcall	outDig
		mov		Number	,	mCoun3
		rcall	outDig
		rcall	DP1
		mov		Number	,	mCoun2
		rcall	outDig
		rcall	DP2
		mov		Number	,	mCoun1
		rcall	outDig
		ldi		Number	,	0b00001111
		
		ret

;----------------------------------------------------------------------------------------------------------
; Minuten x 1

Dunk04:
		cli
		rcall	outCon
		ldi		Number	,	0b00001111
		rcall	outDig
		rcall	outDig
		rcall	outDig
		rcall	outDig
		rcall	DP1
		rcall	outDig
		rcall	DP2
		mov		Number	,	mCoun3
		rcall	outDig
		rcall	DP1
		mov		Number	,	mCoun2
		rcall	outDig
		rcall	DP2
		mov		Number	,	mCoun1
		rcall	outDig
		ldi		Number	,	0b00001111
		
		ret
;----------------------------------------------------------------------------------------------------------
; Minuten x 1

Hell04:
		cli
		rcall	outCon
		ldi		Number	,	0b00001111
		rcall	outDig
		rcall	outDig
		rcall	outDig
		rcall	outDig
		rcall	DP1
		mov		Number	,	mCoun4
		rcall	outDig
		rcall	DP2
		mov		Number	,	mCoun3
		rcall	outDig
		rcall	DP1
		mov		Number	,	mCoun2
		rcall	outDig
		rcall	DP2
		mov		Number	,	mCoun1
		rcall	outDig
		ldi		Number	,	0b00001111
		
		ret

;----------------------------------------------------------------------------------------------------------
; Sekunden x 10

Dunk05:
		cli
		rcall	outCon
		ldi		Number	,	0b00001111
		rcall	outDig
		rcall	outDig
		rcall	outDig
		rcall	outDig
		rcall	DP1
		mov		Number	,	mCoun4
		rcall	outDig
		rcall	DP2
		mov		Number	,	mCoun3
		rcall	outDig
		rcall	DP1
		mov		Number	,	mCoun2
		rcall	outDig
		rcall	DP2
		mov		Number	,	mCoun1
		rcall	outDig
		ldi		Number	,	0b00001111
		
		ret

;----------------------------------------------------------------------------------------------------------
; Sekunden x 10

Hell05:
		cli
		rcall	outCon
		rcall	outDig
		rcall	outDig
		ldi		Number	,	0b00001111
		rcall	outDig
		mov		Number	,	mCoun5
		rcall	outDig
		cpi		Number	,	0b00000000
		rcall	DP1
		mov		Number	,	mCoun4
		rcall	outDig
		rcall	DP2
		mov		Number	,	mCoun3
		rcall	outDig
		rcall	DP1
		mov		Number	,	mCoun2
		rcall	outDig
		rcall	DP2
		mov		Number	,	mCoun1
		rcall	outDig
		ldi		Number	,	0b00001111
		
		ret

;----------------------------------------------------------------------------------------------------------
; Sekunden x 1

Dunk06:
		cli
		rcall	outCon
		rcall	outDig
		rcall	outDig
		ldi		Number	,	0b00001111
		rcall	outDig
		mov		Number	,	mCoun5
		rcall	outDig
		rcall	DP1
		mov		Number	,	mCoun4
		rcall	outDig
		rcall	DP2
		mov		Number	,	mCoun3
		rcall	outDig
		rcall	DP1
		mov		Number	,	mCoun2
		rcall	outDig
		rcall	DP2
		mov		Number	,	mCoun1
		rcall	outDig
		ldi		Number	,	0b00001111
				
		ret

;----------------------------------------------------------------------------------------------------------
; Sekunden x 1

Hell06:
		cli
		rcall	outCon
		rcall	outDig
		rcall	outDig

		sbic	PIND	,	5				; bei 6 Dekaden Betrieb Dezimalpunkt
		rcall	DP1							; hinter Minuten x 1 ausblenden
		mov		Number	,	mCoun6			;
		rcall	outDig						;
		sbic	PIND	,	5				;
		rcall	DP2							;

		mov		Number	,	mCoun5
		rcall	outDig
		rcall	DP1
		mov		Number	,	mCoun4
		rcall	outDig
		rcall	DP2
		mov		Number	,	mCoun3
		rcall	outDig
		rcall	DP1
		mov		Number	,	mCoun2
		rcall	outDig
		rcall	DP2
		mov		Number	,	mCoun1
		rcall	outDig
		ldi		Number	,	0b00001111
				
		ret

;----------------------------------------------------------------------------------------------------------
; Sekunden x 0.10

Dunk07:
		cli
		rcall	outCon
		rcall	outDig
		ldi		Number	,	0b00001111
		rcall	outDig

		sbic	PIND	,	5				; bei 6 Dekaden Betrieb Dezimalpunkt
		rcall	DP1							; hinter Minuten x 1 ausblenden
		mov		Number	,	mCoun6			;
		rcall	outDig						;
		sbic	PIND	,	5				;
		rcall	DP2							;

		mov		Number	,	mCoun5
		rcall	outDig
		rcall	DP1
		mov		Number	,	mCoun4
		rcall	outDig
		rcall	DP2
		mov		Number	,	mCoun3
		rcall	outDig
		rcall	DP1
		mov		Number	,	mCoun2
		rcall	outDig
		rcall	DP2
		mov		Number	,	mCoun1
		rcall	outDig
		ldi		Number	,	0b00001111
				
		ret

;----------------------------------------------------------------------------------------------------------
; Sekunden x 0.10

Hell07:
		cli
		cbi		PORTC	,	0b00000100
		rcall	outCon
		rcall	outDig
		mov		Number	,	mCoun7
		rcall	outDig

		sbic	PIND	,	5				; bei 6 Dekaden Betrieb Dezimalpunkt
		rcall	DP1							; hinter Minuten x 1 ausblenden
		mov		Number	,	mCoun6			;
		rcall	outDig						;
		sbic	PIND	,	5				;
		rcall	DP2							;

		mov		Number	,	mCoun5
		rcall	outDig
		rcall	DP1
		mov		Number	,	mCoun4
		rcall	outDig
		rcall	DP2
		mov		Number	,	mCoun3
		rcall	outDig
		rcall	DP1
		mov		Number	,	mCoun2
		rcall	outDig
		rcall	DP2
		mov		Number	,	mCoun1
		rcall	outDig
		ldi		Number	,	0b00001111
				
		ret

;----------------------------------------------------------------------------------------------------------
; Sekunden x 0.01

Dunk08:
		cli
		rcall	outCon
		ldi		Number	,	0b00001111
		rcall	outDig
		mov		Number	,	mCoun7
		rcall	outDig

		sbic	PIND	,	5				; bei 6 Dekaden Betrieb Dezimalpunkt
		rcall	DP1							; hinter Minuten x 1 ausblenden
		mov		Number	,	mCoun6			;
		rcall	outDig						;
		sbic	PIND	,	5				;
		rcall	DP2							;

		mov		Number	,	mCoun5
		rcall	outDig
		rcall	DP1
		mov		Number	,	mCoun4
		rcall	outDig
		rcall	DP2
		mov		Number	,	mCoun3
		rcall	outDig
		rcall	DP1
		mov		Number	,	mCoun2
		rcall	outDig
		rcall	DP2
		mov		Number	,	mCoun1
		rcall	outDig
		ldi		Number	,	0b00001111
				
		ret

;----------------------------------------------------------------------------------------------------------
; Sekunden x 0.01

Hell08:
		cli
		rcall	outCon
		mov		Number	,	mCoun8
		rcall	outDig
		mov		Number	,	mCoun7
		rcall	outDig

		sbic	PIND	,	5				; bei 6 Dekaden Betrieb Dezimalpunkt
		rcall	DP1							; hinter Minuten x 1 ausblenden
		mov		Number	,	mCoun6			;
		rcall	outDig						;
		sbic	PIND	,	5				;
		rcall	DP2							;

		mov		Number	,	mCoun5
		rcall	outDig
		rcall	DP1
		mov		Number	,	mCoun4
		rcall	outDig
		rcall	DP2
		mov		Number	,	mCoun3
		rcall	outDig
		rcall	DP1
		mov		Number	,	mCoun2
		rcall	outDig
		rcall	DP2
		mov		Number	,	mCoun1
		rcall	outDig
		ldi		Number	,	0b00001111
				
		ret

;----------------------------------------------------------------------------------------------------------
; Dezimalpunkt

DP1:
		cbi		PORTC	,	2
		ret

DP2:
		sbi		PORTC	,	2
		ret

;----------------------------------------------------------------------------------------------------------
